unit Fonts;

interface

uses
    Windows, Messages, Classes, SysUtils, Graphics;

//=============================================================================
//
//  ꎞItHgCXg[NX
//
//=============================================================================
type
    TInstallFont = class
    protected
        FFilePath: string;
        FInstalled : Boolean;
        FDispName: string;
    public
        constructor	Create(const FilePath: string);
        destructor Destroy; override;
        function Install(): Boolean;
        procedure UnInstall();
    published
        property Installed: Boolean read FInstalled;
        property FilePath: string read FFilePath;
        property DispName: string read FDispName;
    end;

var
    MessageOut: TStrings = nil;

(*-----------------------------------------------------------------------------

    Screen.Fonts ̑ɂNX

    TLogFontA = packed record
        lfHeight    : Longint;      //  tHg̘_
        lfWidth     : Longint;      //  ̕ϕ
        lfEscapement: Longint;      //  eLXgs̊px
        lfOrientation: Longint;     //  x[XC̊px
        lfWeight    : Longint;      //  tHg̑
        lfItalic    : Byte;         //  C^bN̑̃tO
        lfUnderline : Byte;         //  t̃tO
        lfStrikeOut : Byte;         //  ł̃tO
        lfCharSet   : Byte;         //  Zbgʎq
        lfOutPrecision: Byte;       //  o͐x
        lfClipPrecision: Byte;      //  NbsOx
        lfQuality   : Byte;         //  o͕i
        lfPitchAndFamily: Byte;     //  sb`ƃtHgt@~̃tO
        lfFaceName  : array[0..LF_FACESIZE - 1] of AnsiChar;
                                    //  ^CvtFCX
    end;

    TEnumLogFont = packed record
        elfLogFont  : TLogFontA;    //  _tHg
        elfFullName : array[0..LF_FULLFACESIZE - 1] of AnsiChar;
                                    //  tHg̃tl[
        elfStyle    : array[0..LF_FACESIZE - 1] of AnsiChar;
                                    //  tHgX^C
    end;

    TNewTextMetric = record
        tmHeight    : Longint;      //  ̍
        tmAscent    : Longint;      //  ̃AZg
        tmDescent   : Longint;      //  ̃fBZg
        tmInternalLeading: Longint; //  fBO
        tmExternalLeading: Longint; //  OfBO
        tmAveCharWidth: Longint;    //  ̕ϕ
        tmMaxCharWidth: Longint;    //  ̍ő啝
        tmWeight    : Longint;      //  {[h
        tmOverhang  : Longint;      //  I[o[nO
        tmDigitizedAspectX: Longint;//  AXyNg
        tmDigitizedAspectY: Longint;//  AXyNg
        tmFirstChar : AnsiChar;     //  ŏ̕
        tmLastChar  : AnsiChar;     //  Ō̕
        tmDefaultChar: AnsiChar;    //  ftHg̕
        tmBreakChar : AnsiChar;     //  ؂蕶
        tmItalic    : Byte;         //  C^bNtO
        tmUnderlined: Byte;         //  tO
        tmStruckOut : Byte;         //  łtO
        tmPitchAndFamily: Byte;     //  sb`ƃt@~̃tO
        tmCharSet   : Byte;         //  Zbg
        ntmFlags    : DWORD;        //  rbg}XN
        ntmSizeEM   : UINT;         //  TPʂŕ\empTCY
        ntmCellHeight: UINT;        //  TPʂŕ\Z
        ntmAvgWidth : UINT;         //  TPʂŕ\̕ϕ
    end;

-----------------------------------------------------------------------------*)
type
    //  񋓂ꂽtHg̏ێNX
    TFontKeeper = class
    private
        FFontType   : integer;
        FEnumLogFont: TEnumLogFont;
        FTextMetrics: TNewTextMetric;
    public
        constructor Create(FontType: integer; LogFont: TEnumLogFont; TextMetrics: TNewTextMetric);
        property FontType: integer read FFontType;
        property EnumLogFont: TEnumLogFont read FEnumLogFont;
        property TextMetrics: TNewTextMetric read FTextMetrics;
    end;

    //  tHg̈ꗗێNX
    TScreenFonts = class
    private
        FUpdating : Boolean;
        FWndHandle: THandle;        //  EBhÉuӂv邽߂̃nh
        FFonts    : TStringList;    //  tHgێXg
        FAutoRefresh: Boolean;      //  tbV
    protected
        procedure   WndProc(var Msg: TMessage);
        procedure   Clear();
        function    GetFontKeeper(index: integer): TFontKeeper;
        function    GetEnumLogFont(index: integer): TEnumLogFont;
        function    GetTextMetric(index: integer): TNewTextMetric;
        function    GetLogFont(index: integer): TLogFont;
    public
        constructor Create(const AutoRefresh: Boolean);
        destructor  Destroy(); override;
        procedure   Refresh();
        property Fonts: TStringList read FFonts;
        property FontKeeper[index: integer]: TFontKeeper read GetFontKeeper;
        property EnumLogFont[index: integer]: TEnumLogFont read GetEnumLogFont;
        property TextMetrics[index: integer]: TNewTextMetric read GetTextMetric;
        property LogFont[index: integer]: TLogFont read GetLogFont;
        property Updating: Boolean read FUpdating;
        property AutoRefresh: Boolean read FAutoRefresh write FAutoRefresh;
    end;

type
    TRefreshProc = procedure() of object;

var
    ScreenFonts: TScreenFonts = nil;
    RefreshProc: TRefreshProc = nil;

function KanaToChars(AKana: string): string;

implementation

uses
    otff, CodeGuruC3659;

var
    WorkList: TStrings = nil;

//=============================================================================
//
//  ꎞItHgCXg[NX
//
//=============================================================================

//-----------------------------------------------------------------------------
//  RXgN^
constructor TInstallFont.Create(const FilePath: string);
var
    ext: string;
begin
    inherited Create;
    FFilePath := FilePath;
    FInstalled := False;

    //  \擾Ă݂
    ext := AnsiLowerCase(ExtractFileExt(FFilePath));
    if (ext = '.ttf') then
    begin
        FDispName := GetFontNameFromFile(FFilePath);
{
    //  RpCIvV͈̔̓`FbN~߂ȂƑʖڂȂ̂Ō
    end
    else if (ext = '.ttc') then
    begin
        WorkList.Clear;
        GetFontNameFromTTC(FFilePath, WorkList);
        FDispName := WorkList.CommaText;
}
    end;
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TInstallFont.Destroy;
begin
    if FInstalled then UnInstall();
    inherited Destroy;
end;

//-----------------------------------------------------------------------------
//  tHgCXg[
function TInstallFont.Install(): Boolean;
begin
    //  CXg[ĂȂꍇ
    if not FInstalled then
    begin
        //CXg[
        FInstalled := (AddFontResource(PChar(FFilePath)) <> 0);
        //̃AvP[Vɂʒm
        if FInstalled then SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);

        //  bZ[W\
        if (MessageOut <> nil) then
        begin
            if (FInstalled) then
            begin
                MessageOut.Add(Format(' OK  >> INSTALLED %s', [FFilePath]));
            end
            else
            begin
                MessageOut.Add(Format('FAIL >> NOT INSTALLED %s', [FFilePath]));
            end;
        end;
    end
    //  CXg[ς݂̏ꍇ
    else
    begin
        //  bZ[W\
        if (MessageOut <> nil) then
        begin
            MessageOut.Add(Format(' OK  >> ALREADY INSTALLED %s', [FFilePath]));
        end;
    end;
    Result := FInstalled;
end;

//-----------------------------------------------------------------------------
//  tHgACXg[
procedure TInstallFont.UnInstall();
begin
    //  CXg[ς݂̏ꍇ
    if FInstalled then
    begin
        //폜
        RemoveFontResource(PChar(FFilePath));
        //̃AvP[Vɂʒm
        SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
        //  ԃtOOFF
        FInstalled := False;
        //  bZ[W\
        if (MessageOut <> nil) then
        begin
            MessageOut.Add(Format(' OK  >> UNINSTALL %s', [FFilePath]));
        end;
    end;
end;



//=============================================================================
//
//  Screen.Font uNX
//
//=============================================================================



//-----------------------------------------------------------------------------
//  RXgN^
constructor TFontKeeper.Create(FontType: integer; LogFont: TEnumLogFont;
                                TextMetrics: TNewTextMetric);
begin
    FFontType := FontType;
    FEnumLogFont := LogFont;
    FTextMetrics := TextMetrics;
end;

//-----------------------------------------------------------------------------
//  EBhÊӂƂ̃EBhEvV[W
procedure   TScreenFonts.WndProc(var Msg: TMessage);
begin
    //  tHg̍\ς
    if Msg.Msg = WM_FONTCHANGE then
    begin
        //  tOătbV
        if FAutoRefresh then Refresh();
    end else
    //  łȂȂ
    begin
        //  ۓ
        Msg.Result := DefWindowProc(FWndHandle, Msg.Msg, Msg.wParam, Msg.lParam);
    end;
end;

//-----------------------------------------------------------------------------
//  RXgN^
constructor TScreenFonts.Create(const AutoRefresh: Boolean);
begin
    inherited Create;
    //  tO
    FUpdating := false;
    //  tbV
    FAutoRefresh := AutoRefresh;
    //  tHgێXg쐬
    FFonts := TStringList.Create;
    //  EBhÊӂ邽߂̃nh蓖
    FWndHandle := AllocateHWnd(WndProc);
    //  tHgXgXV
    Refresh();
end;

//-----------------------------------------------------------------------------
//  RXgN^
destructor  TScreenFonts.Destroy();
begin
    //  EBhÊӂ̂߂
    DeallocateHWnd(FWndHandle);
    //  tHgێXg
    FFonts.Free;
    inherited Destroy;
end;

//-----------------------------------------------------------------------------
//  NA
procedure   TScreenFonts.Clear();
begin
    while FFonts.Count > 0 do
    begin
        FFonts.Objects[0].Free;
        FFonts.Delete(0);
    end;
    FFonts.Clear();
end;

//------------------------------------------------------------------------
//  Delphi Win32 Graphics API t@X P618-
//  R[obN֐
function    FontEnumProc(LogFont: PEnumLogFont; TextMetrics: PNewTextMetric;
                FontType: integer; Strings: LPARAM): integer; stdcall;
var
    FaceName: string;
    FontKeeper: TFontKeeper;
begin
    //  tHgƃtHg^CvXgɒǉ
    FaceName := TEnumLogFont(LogFont^).elfLogFont.lfFaceName;
    if (Copy(FaceName, 1, 1) <> '@') then
    begin
        FontKeeper := TFontKeeper.Create(FontType, LogFont^, TextMetrics^);
        TStrings(Strings).AddObject(FaceName, FontKeeper);
    end;
    //  񋓌p
    Result := 1;
end;

//-----------------------------------------------------------------------------
//  tHgꗗXV
procedure   TScreenFonts.Refresh();
var
    DesktopDC: HDC;
begin
    FUpdating := true;
    Clear();
    DesktopDC := GetDC(GetDesktopWindow);
    EnumFontFamilies(DesktopDC, nil, @FontEnumProc, LPARAM(FFonts));
    ReleaseDC(GetDesktopWindow, DesktopDC);
    FFonts.Sort();
    if Assigned(RefreshProc) then RefreshProc();
    FUpdating := false;
end;

//-----------------------------------------------------------------------------
//  vpeBANZX - 1
function    TScreenFonts.GetFontKeeper(index: integer): TFontKeeper;
begin
    Result := TFontKeeper(FFonts.Objects[index]);
end;
//-----------------------------------------------------------------------------
//  vpeBANZX - 2
function    TScreenFonts.GetEnumLogFont(index: integer): TEnumLogFont;
begin
    Result := FontKeeper[index].EnumLogFont;
end;
//-----------------------------------------------------------------------------
//  vpeBANZX - 3
function    TScreenFonts.GetTextMetric(index: integer): TNewTextMetric;
begin
    Result := FontKeeper[index].TextMetrics;
end;
//-----------------------------------------------------------------------------
//  vpeBANZX - 4
function    TScreenFonts.GetLogFont(index: integer): TLogFont;
begin
    Result := FontKeeper[index].EnumLogFont.elfLogFont;
end;



//=============================================================================
//
//  ϊ
//
//=============================================================================



var
    KanaTable: TStrings;

//-----------------------------------------------------------------------------
//  JitHg̃JiƉpƂ̑Ήt
function KanaToChar(AKana: string): Char;
var
    Index: integer;
begin
    Index := KanaTable.IndexOf(AKana);
    if Index <> -1 then
    begin
        Result := Chr(Integer(KanaTable.Objects[Index]))
    end
    else
    begin
        Result := ' ';
    end;
end;

//-----------------------------------------------------------------------------
//  JitHg̃JiBƉpBƂ̑Ήt
function KanaToChars(AKana: string): string;
var
    i: integer;
begin
    Result := '';
    i := 1;
    while i <= Length(AKana) do
    begin
        if ByteType(AKana, i) = mbLeadByte then
        begin
            Result := Result + KanaToChar(AKana[i] + AKana[i + 1]);
            Inc(i, 2);
        end
        else
        begin
            Inc(i, 1);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  JitHg̃JiƉpƂ̑Ήte[u
procedure SetKanaTable();
begin
    with KanaTable do
    begin
        Clear;
        AddObject('', TObject('3'));
        AddObject('', TObject('e'));
        AddObject('', TObject('4'));
        AddObject('', TObject('5'));
        AddObject('', TObject('6'));

        AddObject('', TObject('t'));
        AddObject('', TObject('g'));
        AddObject('', TObject('h'));
        AddObject('', TObject(':'));
        AddObject('', TObject('b'));

        AddObject('', TObject('x'));
        AddObject('', TObject('d'));
        AddObject('', TObject('r'));
        AddObject('', TObject('p'));
        AddObject('', TObject('c'));

        AddObject('', TObject('q'));
        AddObject('', TObject('a'));
        AddObject('', TObject('z'));
        AddObject('', TObject('w'));
        AddObject('', TObject('s'));

        AddObject('', TObject('u'));
        AddObject('', TObject('i'));
        AddObject('', TObject('1'));
        AddObject('', TObject(','));
        AddObject('', TObject('k'));

        AddObject('', TObject('f'));
        AddObject('', TObject('v'));
        AddObject('', TObject('2'));
        AddObject('', TObject('^'));
        AddObject('', TObject('-'));

        AddObject('', TObject('j'));
        AddObject('', TObject('n'));
        AddObject('', TObject(']'));
        AddObject('', TObject('/'));
        AddObject('', TObject('m'));

        AddObject('', TObject('7'));
        AddObject('', TObject('8'));
        AddObject('', TObject('9'));

        AddObject('', TObject('o'));
        AddObject('', TObject('l'));
        AddObject('', TObject('.'));
        AddObject('', TObject(';'));
        AddObject('', TObject('N'));

        AddObject('', TObject('0'));
        AddObject('', TObject('}'));
        AddObject('', TObject('y'));

        //

        AddObject('', TObject('J'));
        AddObject('', TObject('G'));
        AddObject('', TObject('H'));
        AddObject('', TObject('*'));
        AddObject('', TObject('B'));

        AddObject('', TObject('X'));
        AddObject('', TObject('D'));
        AddObject('', TObject('R'));
        AddObject('', TObject('P'));
        AddObject('', TObject('C'));

        AddObject('', TObject('Q'));
        AddObject('', TObject('A'));
        AddObject('', TObject('M'));
        AddObject('', TObject('W'));
        AddObject('', TObject('S'));

        AddObject('', TObject('F'));
        AddObject('', TObject('V'));
        AddObject('', TObject('?'));
        AddObject('', TObject('`'));
        AddObject('', TObject('='));

        AddObject('', TObject('U'));
        AddObject('', TObject('I'));
        AddObject('', TObject('!'));
        AddObject('', TObject('<'));
        AddObject('', TObject('K'));

        AddObject('', TObject('#'));
        AddObject('', TObject('E'));
        AddObject('', TObject('$'));
        AddObject('', TObject('%'));
        AddObject('', TObject('&'));

        AddObject('', TObject('('));
        AddObject('', TObject(')'));
        AddObject('', TObject('Z'));
        AddObject('|', TObject('['));
    end;

end;


{
type
    TFontHacker = class
    private
        FWND: HWND;
        FOldFont: HFONT;
        FNewFont: HFONT;
    public
        constructor Create();
        destructor Destroy(); override;
        procedure Hack(const Target: HWND; NewFont: TFont);
        procedure Back();
    end;
}

{
constructor TFontHacker.Create();
begin
    //  nhĂ
    FWND     := INVALID_HANDLE_VALUE;
    FOldFont := INVALID_HANDLE_VALUE;
    FNewFont := INVALID_HANDLE_VALUE;
end;

destructor TFontHacker.Destroy();
begin
    Back();
end;

procedure TFontHacker.Hack(const Target: HWND; NewFont: TFont);
begin
    FWND := Target;

    //  VtHg
    FNewFont := NewFont.Handle;
    //FNewFont := GetStockObject(ANSI_FIXED_FONT);    

    //  Xݒ肳ĂtHg(Ŗ߂߂)ێĂ
    FOldFont := SendMessage(FWND, WM_GETFONT, 0, 0);

    //  ւ
    SendMessage(FWND, WM_SETFONT, FNewFont, MakeLong(1,0));
    //SendMessage(FTargetWND, WM_PAINT, 0, 0);
end;

procedure TFontHacker.Back();
begin
    //  ^[QbgEBhEłȂ(nbLOĂƂ݂Ȃ)
    if IsWindow(FWND) then
    begin
        //  ƂƂ̃tHgɖ߂
        SendMessage(FWND, WM_SETFONT, FOldFont, MakeLong(1,0));
        //SendMessage(FWND, WM_SETFONT, 0, MakeLong(1,0));

        FWND     := INVALID_HANDLE_VALUE;
        FOldFont := INVALID_HANDLE_VALUE;
        FNewFont := INVALID_HANDLE_VALUE;
    end;
end;
}


initialization
    WorkList := TStringList.Create;
    ScreenFonts := TScreenFonts.Create(true);
    KanaTable := TStringList.Create;
    SetKanaTable();
finalization
    WorkList.Free;
    ScreenFonts.Free;
    KanaTable.Free;
end.

