unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, StdCtrls, Menus, Buttons, IniFiles;

type
  TMainForm = class(TForm)
    Page: TPageControl;
    TabFontUNow: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Panel1: TPanel;
    Timer1: TTimer;
    MemoMessage: TMemo;
    Splitter1: TSplitter;
    MainMenu: TMainMenu;
    MenuFile: TMenuItem;
    MenuQuit: TMenuItem;
    MenuFont: TMenuItem;
    MenuInstall: TMenuItem;
    MenuUninstall: TMenuItem;
    MenuDeleteFromList: TMenuItem;
    MenuClearList: TMenuItem;
    MenuPreference: TMenuItem;
    MenuIgnoreFolderDrop: TMenuItem;
    MenuScanSubFolder: TMenuItem;
    MenuHelp: TMenuItem;
    MenuAbout: TMenuItem;
    LboxFont: TListBox;
    Panel2: TPanel;
    BtnInstall: TBitBtn;
    BtnUninstall: TBitBtn;
    BtnDeleteFromList: TBitBtn;
    MenuSelectAll: TMenuItem;
    MenuUnselectAll: TMenuItem;
    N1: TMenuItem;
    MenuShowHint: TMenuItem;
    MenuTryDrawAsIs: TMenuItem;
    N3: TMenuItem;
    PopupMenu: TPopupMenu;
    PenuInstall: TMenuItem;
    PenuUninstall: TMenuItem;
    N4: TMenuItem;
    PenuOpenAsIs: TMenuItem;
    PenuOpenFolderIn: TMenuItem;
    PenuProperty: TMenuItem;
    N5: TMenuItem;
    PenuDeleteFromList: TMenuItem;
    Panel3: TPanel;
    Image1: TImage;
    MenuJuncCrash: TMenuItem;
    Panel4: TPanel;
    CboxScreenFont: TComboBox;
    TbarFontSize: TTrackBar;
    EboxKana: TEdit;
    MemConverted: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure Panel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MenuIgnoreFolderDropClick(Sender: TObject);
    procedure MenuAboutClick(Sender: TObject);
    procedure MenuQuitClick(Sender: TObject);
    procedure MenuShowHintClick(Sender: TObject);
    procedure MenuInstallClick(Sender: TObject);
    procedure MenuUninstallClick(Sender: TObject);
    procedure MenuSelectAllClick(Sender: TObject);
    procedure MenuUnselectAllClick(Sender: TObject);
    procedure MenuDeleteFromListClick(Sender: TObject);
    procedure MenuClearListClick(Sender: TObject);
    procedure PenuInstallClick(Sender: TObject);
    procedure PenuUninstallClick(Sender: TObject);
    procedure PenuOpenAsIsClick(Sender: TObject);
    procedure PenuOpenFolderInClick(Sender: TObject);
    procedure PenuPropertyClick(Sender: TObject);
    procedure PenuDeleteFromListClick(Sender: TObject);
    procedure LboxFontDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure LboxFontMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MenuJuncCrashClick(Sender: TObject);
    procedure PageChange(Sender: TObject);
    procedure CboxScreenFontChange(Sender: TObject);
    procedure EboxKanaChange(Sender: TObject);
    procedure MenuTryDrawAsIsClick(Sender: TObject);
  private
    //  hbOAhhbv֌W
    AllocHandle:HWND;
    FDropFolds: TStrings;
    FDropFiles: TStrings;
    procedure NewWndProc(var Msg: TMessage);
    procedure UpdateDropList(const Path: string);
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DropFiles;
    procedure Scan();
  protected
    //  hbOAhhbv֌W
    procedure CreateParams(var Params: TCreateParams);override;
  public
    //  hbOAhhbv֌W
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  private
    //  Ђ炪ȕϊ֌W
    EditPreProc	:TWndMethod;
    procedure EditSubclassProc(var Msg: TMessage);
    function GetIMECompString(CE: TCustomEdit; Index: DWORD):string;
    function IsLastCharHiragana(s: string):Boolean;
    procedure ChangeMemoFont(const FontName: string; const FontCharSet: TFontCharset;
                            const FontSize: integer);
  private
    //  Ȃ
    InMouseDown: Boolean;
    FStrBuf: TStringList;
    procedure AppShowHint(var HintStr: string;
      var CanShow: Boolean; var HintInfo: THintInfo);
  private

  public

  end;

var
  MainForm: TMainForm;

//-----------------------------------------------------------------------------
const
    //  dNp̔閧̒l
    //  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N011.html
    UNIQUE_NAM: string = '{F8D4A61A-5AB6-472F-97F0-523387E41E27}';
    UNIQUE_NUM: Cardinal = $00001112;

    //  Ήgq
    FONT_EXT = '.fon,.fnt,.ttf,.ttc,.fot,.otf,.mmm,.pfb,.pfm';

implementation

{$R *.dfm}

uses
    ShellApi, Imm,
    Util, Fonts, ScanFile, Info;

const
    //  F
    GC_NONCELLAREA = TColor($00EEEEEE);     //  ͈͊O̐F

    GC_BG_EMPTY    = TColor($00CCCCCC);     //  ZwiF
    GC_BG_FOCUSED  = TColor($00F0CAA6);     //  tH[JXZwiF
    GC_BG_SELECT   = TColor($00F0CAFF);     //  IZwiF
    GC_BG_NORMAL   = TColor($00F0FBFF);     //  ʏZwiF

    GC_FG_FOCUSED  = TColor($000000);       //  tH[JXZF
    GC_FG_SELECT   = TColor($000000);       //  IZF
    GC_FG_NORMAL   = TColor($000000);       //  ʏZF




//=============================================================================
//
//  tHgt@CǗ
//
//=============================================================================



var
    UMemIniFile: TMemIniFile = nil;
    UFontPathList: TStringList = nil;

//-----------------------------------------------------------------------------
//  tHgǉ
procedure AddFontObject(const Path: string);
var
    Work: TInstallFont;
begin
    //  ɑ݂Ăꍇ
    if (UFontPathList.IndexOf(Path) <> -1) then
    begin
        //  
    end
    else
    begin
        //  IuWFNg쐬
        Work := TInstallFont.Create(Path);

        //  IuWFNgǗNXɒǉ
        UFontPathList.AddObject(Path, Work);

        //  f[^ǗNXɂǉ
        UMemIniFile.WriteString(Path, 'FileName', ExtractFileName(Path));
        //UMemIniFile.UpdateFile();
    end;
end;

//-----------------------------------------------------------------------------
//  ǗpIuWFNg쐬
procedure CreateManagerObject();
var
    i: integer;
    Temp: TStringList;
begin
    //  f[^ǗNX쐬
    UMemIniFile := TMemIniFile.Create(ChangeFileExt(ParamStr(0), '.dat'));

    //  IuWFNgǗNX쐬
    UFontPathList := TStringList.Create();

    Temp := TStringList.Create;
    try
        //  ǂݎ
        UMemIniFile.ReadSections(Temp);

        //  ȌԂ𕜌
        for i := 0 to Temp.Count - 1 do
        begin
            AddFontObject(Temp.Strings[i]);
        end;
    finally
        Temp.Free;
    end;
end;

//-----------------------------------------------------------------------------
//  ǗpIuWFNgNA
procedure DeleteFromManagerObject(const Path: string);
var
    Index: integer;
begin
    //  f[^ǗNX폜
    UMemIniFile.EraseSection(Path);
    //UMemIniFile.UpdateFile();

    //  IuWFNgǗNX폜
    Index := UFontPathList.IndexOf(Path);
    if (Index <> -1) then
    begin
        UFontPathList.Objects[Index].Free();
        UFontPathList.Delete(Index);
    end;
end;

//-----------------------------------------------------------------------------
//  ǗpIuWFNgNA
procedure ClearManagerObject(const DoEntryClear: Boolean);
begin
    //  f[^ǗNXNA
    if (DoEntryClear) then
    begin
        UMemIniFile.Clear();
        //UMemIniFile.UpdateFile();
    end;

    //  IuWFNgǗNXNA
    while (UFontPathList.Count > 0) do
    begin
        UFontPathList.Objects[0].Free();
        UFontPathList.Delete(0);
    end;
end;

//-----------------------------------------------------------------------------
//  ǗpIuWFNgj
procedure DestroyManagerObject();
begin
    ClearManagerObject(False);

    //  f[^ǗNXj
    UMemIniFile.UpdateFile();
    UMemIniFile.Free();

    //  IuWFNgǗNXj
    UFontPathList.Free();
end;




//=============================================================================
//
//  hbOAhhbvւ̑Ή
//
//=============================================================================



//-----------------------------------------------------------------------------
//  j[NȃNXw肵ăbZ[WMpEBhE֐
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N012.html
function AllocMsgWnd(Method: TWndMethod; ClassName:string): HWND;
var
    DummyClass: TWndClass;
begin
    FillChar(DummyClass, SizeOf(TWndClass), #0);
    DummyClass.hInstance := hInstance;
    DummyClass.lpfnWndProc := @DefWindowProc;
    DummyClass.lpszClassName := PChar(ClassName);
    Windows.RegisterClass(DummyClass);
    Result := CreateWindowEx(WS_EX_TOOLWINDOW, DummyClass.lpszClassName,
                             '', WS_POPUP, 0, 0, 0, 0, 0, 0, hInstance, nil);
    if Assigned(Method) then
        SetWindowLong(Result,GWL_WNDPROC,LongInt(Classes.MakeObjectInstance(Method)));
end;

//-----------------------------------------------------------------------------
//  RXgN^
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N007.html
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N012.html
constructor TMainForm.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    //  bZ[WMp
    if AllocHandle = 0 then AllocHandle := AllocMsgWnd(NewWndProc, UNIQUE_NAM);

    //  ǂݍ
    CreateManagerObject();

    //  Xg{bNXs
    LboxFont.Count := UFontPathList.Count;
    //  tHgCXg[pNX̃bZ[Wo͐
    //  tH[i֘At
    Fonts.MessageOut := MemoMessage.Lines;
end;

//-----------------------------------------------------------------------------
//  fXgN^
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N007.html
destructor TMainForm.Destroy;
begin
    //  j
    DestroyManagerObject();

    //  bZ[WMp
    Classes.DeallocateHwnd(AllocHandle);
    AllocHandle := 0;
    inherited;
end;

//-----------------------------------------------------------------------------
//  ւp̃EBhEvV[W
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=268
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N007.html
procedure TMainForm.NewWndProc(var Msg: TMessage);
var
    i: integer;
    Buf: PChar;
    CopyData: PCopyDataStruct;
begin
    case Msg.Msg of

    //  ʂ̃CX^X瑗Ăe
    WM_COPYDATA:
        begin
            FDropFolds.Clear();
            FDropFiles.Clear();

            CopyData := PCopyDataStruct(Msg.LParam);
            if CopyData^.dwData = UNIQUE_NUM then
            begin
                Buf := StrALloc(CopyData^.cbData);
                try
                    StrCopy(Buf, CopyData^.lpData);
                    FStrBuf.CommaText := Buf;
                finally
                    StrDispose(Buf);
                end;
                for i := 0 to FStrBuf.Count - 1 do
                begin
                    //  d
                    UpdateDropList(FStrBuf[i]);
                end;

                Scan();
            end;
        end;

    //  ̑̑SĂ̏ꍇ
    else
        Msg.Result := CallWindowProc(@DefWindowProc, AllocHandle,
                                        Msg.Msg, Msg.WParam, Msg.LParam);
    end;
end;

//-----------------------------------------------------------------------------
//  GNXv[̃hbOAhhbv󂯕t悤ɂ
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;

//-----------------------------------------------------------------------------
//  GNXv[hbvꂽ̏
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);
var
    FileName: Array[0..MAX_PATH] of Char;
    i, Count: integer;
begin
    FDropFolds.Clear();
    FDropFiles.Clear();

    //  hbvꂽt@C̐擾
    Count := DragQueryFile(Msg.Drop, DWORD(-1), FileName, SizeOf(FileName));
    for i := 0 to Count - 1 do
    begin
        //  ꂼ̃t@C擾
        DragQueryFile(Msg.Drop, i, FileName, SizeOf(FileName));
        //  d
        UpdateDropList(FileName);
        //  őOʂɎĂ
        //if (MenuActivateAfterDropped.Checked) then SetForegroundWindow(Application.Handle);
    end;
    //  hbv
    DragFinish(Msg.Drop);

    Scan();
end;

//-----------------------------------------------------------------------------
//  tH[\
procedure TMainForm.FormShow(Sender: TObject);
var
    i: integer;
begin
    FDropFolds.Clear();
    FDropFiles.Clear();

    //  NɃACRɃhbvꂽt@C
    for i := 1 to ParamCount do
    begin
        //  d
        UpdateDropList(ParamStr(i));
    end;

    Scan();
end;

//-----------------------------------------------------------------------------
//  hbvꂽpXd
procedure TMainForm.UpdateDropList(const Path: string);
begin
    //  t@C̏ꍇ
    if FileExists(Path) then
    begin
        FDropFiles.Add(Path)
    end

    //  tH_̏ꍇ
    else if DirectoryExists(Path) then
    begin
        //  ȂȂ
        if (not MenuIgnoreFolderDrop.Checked) then FDropFolds.Add(Path);
    end;
end;

//-----------------------------------------------------------------------------
//  
procedure TMainForm.Scan();
var
    i: integer;
begin
    //  󂯎MNA
    FStrBuf.Clear();
    //  hbvꂽSẴt@CEtH_Ώۃt@C𒊏o
    ScanFiles(FONT_EXT, FDropFiles, FDropFolds, FStrBuf, MenuScanSubFolder.Checked);
    //  󂯂Ƃ
    for i := 0 to FStrBuf.Count - 1 do
    begin
        AddFontObject(FStrBuf.Strings[i]);
    end;
    //  ʂɕ\
    LboxFont.Count := UFontPathList.Count;
    LboxFont.Repaint();
end;



//=============================================================================
//
//  tH[Ej
//
//=============================================================================



//-----------------------------------------------------------------------------
//  RXgN^
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  LvV
    Self.Caption := Application.Title + ' - ' + Self.Caption;

    //  GpXg쐬
    FStrBuf := TStringList.Create;
    FDropFolds := TStringList.Create;
    FDropFiles := TStringList.Create;

    //  Lv`łȂ
    InMouseDown := false;

    //  qg\JX^}CY
    Application.OnShowHint := AppShowHint;
    Self.ShowHint := True;

    //  GfBbg{bNX
    EditPreProc := EboxKana.WindowProc;
    EboxKana.WindowProc := EditSubclassProc;
    Page.ActivePageIndex := 0;
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  ɖ߂
    EboxKana.WindowProc := EditPreProc;

    //  qg\߂
    Application.OnShowHint := nil;

    //  GpXgj
    FStrBuf.Free;
    FDropFolds.Free;
    FDropFiles.Free;
end;

//-----------------------------------------------------------------------------
//  Ǝ̃qg\
//  http://www.din.or.jp/~egawa-n/delphi/tips/grid_hint.html
procedure TMainForm.AppShowHint(var HintStr: string;
  var CanShow: Boolean; var HintInfo: THintInfo);
var
    Index: Integer;
    LB: TListBox;
begin
    if HintInfo.HintControl = LboxFont then
    begin
        LB := LboxFont;
        Index := LB.ItemAtPos(HintInfo.CursorPos, True);
        if (Index <> -1) then
        begin
            HintStr := 'eXgf[X';
            //HintStr := FFontList.GetItem(Index).FileHint;
            HintInfo.CursorRect := LB.ItemRect(Index);
            CanShow := (HintInfo.CursorPos.x < HintInfo.CursorRect.Right) and
                       (HintInfo.CursorPos.y < HintInfo.CursorRect.Bottom);
        end
        else
        begin
            //HintStr := LB.Hint;
            HintStr := 't@CtH_hbOAhhbvĂB';
        end;
        HintInfo.ReshowTimeout := 1000
    end;
end;

//-----------------------------------------------------------------------------
//  y[W؂ւ
procedure TMainForm.PageChange(Sender: TObject);
var
    Prev: string;
    Index: integer;
begin
    if (Page.ActivePageIndex = 1) then
    begin
        //  ȌԂł邾Č
        Prev := CboxScreenFont.Text;
        CboxScreenFont.Items.Assign(ScreenFonts.Fonts);
        Index := CboxScreenFont.Items.IndexOf(Prev);
        if (Index = -1) then Index := 0;
        CboxScreenFont.ItemIndex := Index;
        //  K
        EboxKanaChange(EboxKana);
        //  tHgύX
        ChangeMemoFont(
            CboxScreenFont.Text,
            ScreenFonts.FontKeeper[CboxScreenFont.ItemIndex].TextMetrics.tmCharSet,
            TbarFontSize.Position
        );
    end;
end;



//=============================================================================
//
//  eXg
//
//=============================================================================



var
    TargetHandle: HWND = INVALID_HANDLE_VALUE;

//-----------------------------------------------------------------------------
//  ^[QbgEBhE擾̗Jn
procedure TMainForm.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Button = mbLeft) then
    begin
        InMouseDown := true;
        Screen.Cursor := CUR_SEEKER;
    end;
end;

//-----------------------------------------------------------------------------
//  łHłH
procedure TMainForm.Timer1Timer(Sender: TObject);
var
    WH: HWND;
begin
    if InMouseDown then
    begin
        //  ?
        if (GetAsyncKeyState(VK_ESCAPE) <> 0) then
        begin
            InMouseDown := false;
            Screen.Cursor := crDefault;
            Exit;
        end;
        //  }EẌʒũEBhEnh擾
        WH := WindowFromPoint(Mouse.CursorPos);
        //  
        FlashDesktopCanvas(WH, 100);
    end;
end;

//-----------------------------------------------------------------------------
//  ^[QbgEBhE擾̗I
//  http://yokohama.cool.ne.jp/chokuto/urawaza/setfont.html
procedure TMainForm.Panel1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//var
//    FontHacker: TFontHacker;
begin
    //  XpCłȂ΃XLbv
    if InMouseDown then
    begin
        //  tO|ăJ[\ɖ߂
        InMouseDown := false;
        Screen.Cursor := crDefault;
        //  }EX̃EBhEnho
        TargetHandle := WindowFromPoint(Mouse.CursorPos);
        if (TargetHandle <> 0) then
        begin
//            FontHacker := TFontHacker.Create();
//            FontHacker.Hack(TargetHandle, Label1.Font);
//            ShowMessage('');
//            FontHacker.Back();
//            FontHacker.Free();
        end;
    end;
end;



//=============================================================================
//
//  Cj[
//
//=============================================================================



//-----------------------------------------------------------------------------
//  tH_𖳎邩ǂ
procedure TMainForm.MenuIgnoreFolderDropClick(Sender: TObject);
var
    MenuItem: TMenuItem;
begin
    MenuItem := TMenuItem(Sender);
    //  ȂȂTutH_@邩ǂݒ\ɂ
    MenuScanSubFolder.Enabled := (not MenuItem.Checked);
end;

//-----------------------------------------------------------------------------
//  o[W\
procedure TMainForm.MenuAboutClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
//  I
procedure TMainForm.MenuQuitClick(Sender: TObject);
begin
    Self.Close();
end;

//-----------------------------------------------------------------------------
//  ŏčő剻
procedure TMainForm.MenuJuncCrashClick(Sender: TObject);
begin
    Application.Minimize();
    Application.Restore();
end;

//-----------------------------------------------------------------------------
//  qg\邩ǂ
procedure TMainForm.MenuShowHintClick(Sender: TObject);
var
    MenuItem: TMenuItem;
begin
    MenuItem := TMenuItem(Sender);
    Self.ShowHint := MenuItem.Checked;
end;

//-----------------------------------------------------------------------------
//  ItHgCXg[
//  http://forum.nifty.com/fdelphi/samples/00782.html
procedure TMainForm.MenuInstallClick(Sender: TObject);
var
    i, SelCount, DidCount: integer;
    FontFile: TInstallFont;
    R: TRect;
begin
    //  SIĂȂȂ炵Ȃ
    SelCount := LboxFont.SelCount;
    if (SelCount = 0) then Exit;

    //  IɂȂ΃[v𒆒f悤
    DidCount := 0;

    for i := 0 to LboxFont.Count - 1 do
    begin
        //  ESCAPEL[Œf
        if (GetAsyncKeyState(VK_ESCAPE)) <> 0 then
        begin
            MemoMessage.Lines.Add('CANCELED BY USER');
            break;
        end;

        //  IĂ邩
        if not LboxFont.Selected[i] then continue;

        //  IuWFNgo
        FontFile := TInstallFont(UFontPathList.Objects[i]);

        //  CXg[
        FontFile.Install();

        //  `
        R := LboxFont.ItemRect(i);
        InvalidateRect(LboxFont.Handle, @R, True);
        LboxFont.Update;

        //  CNg
        Inc(DidCount);
        if (DidCount >= SelCount) then break;
    end;
end;

//-----------------------------------------------------------------------------
//  ItHgACXg[
//  http://forum.nifty.com/fdelphi/samples/00782.html
procedure TMainForm.MenuUninstallClick(Sender: TObject);
var
    i, SelCount, DidCount: integer;
    FontFile: TInstallFont;
    R: TRect;
begin
    //  SIĂȂȂ炵Ȃ
    SelCount := LboxFont.SelCount;
    if (SelCount = 0) then Exit;

    //  IɂȂ΃[v𒆒f悤
    DidCount := 0;

    for i := 0 to LboxFont.Count - 1 do
    begin
        //  IĂ邩
        if not LboxFont.Selected[i] then continue;

        //  IuWFNgo
        FontFile := TInstallFont(UFontPathList.Objects[i]);

        //  ACXg[
        FontFile.UnInstall();

        //  `
        R := LboxFont.ItemRect(i);
        InvalidateRect(LboxFont.Handle, @R, True);
        LboxFont.Update;

        //  CNg
        Inc(DidCount);
        if (DidCount >= SelCount) then break;
    end;
end;

//-----------------------------------------------------------------------------
//  SI
procedure TMainForm.MenuSelectAllClick(Sender: TObject);
begin
    LboxFont.SelectAll();
end;

//-----------------------------------------------------------------------------
//  SI
procedure TMainForm.MenuUnselectAllClick(Sender: TObject);
begin
    LboxFont.ClearSelection();
end;

//-----------------------------------------------------------------------------
//  ItHgXg폜
//  http://forum.nifty.com/fdelphi/samples/00782.html
procedure TMainForm.MenuDeleteFromListClick(Sender: TObject);
var
    i, SelCount, DidCount: integer;
    FontFile: TInstallFont;
    OldIndex: integer;
begin
    //  SIĂȂȂ炵Ȃ
    SelCount := LboxFont.SelCount;
    if (SelCount = 0) then Exit;

    //  IɂȂ΃[v𒆒f悤
    DidCount := 0;

    //  ԍŏ̑IʒuL^
    OldIndex := -1;

    //  ܂ACXg[
    MenuUninstallClick(MenuUninstall);

    //  ɃIuWFNgĂ
    for i := 0 to LboxFont.Count - 1 do
    begin
        //  ESCAPEL[Œf
        if (GetAsyncKeyState(VK_ESCAPE)) <> 0 then
        begin
            MemoMessage.Lines.Add('CANCELED BY USER');
            break;
        end;

        //  IĂ邩
        if not LboxFont.Selected[i] then continue;

        //  ԍŏȂ
        if (OldIndex = -1) then OldIndex := i;

        //  IuWFNgo
        FontFile := TInstallFont(UFontPathList.Objects[i]);

        //  IuWFNg폜
        DeleteFromManagerObject(FontFile.FilePath);

        //  CNg
        Inc(DidCount);
        if (DidCount >= SelCount) then break;
    end;

    //  Xg{bNX̍s炷
    LboxFont.Count := UFontPathList.Count;

    //  Iʒuł邾Č
    Dec(OldIndex);
    if (OldIndex < 0) then OldIndex := 0;
    if (LboxFont.Count > 0) and (OldIndex < LboxFont.Count) then
    begin
        LboxFont.ItemIndex := OldIndex;
    end;

    //  ĕ`
    LboxFont.Repaint;
end;

//-----------------------------------------------------------------------------
//  XgNA
procedure TMainForm.MenuClearListClick(Sender: TObject);
begin
    ClearManagerObject(True);
    LboxFont.Count := UFontPathList.Count;
    LboxFont.Repaint();
end;

//-----------------------------------------------------------------------------
//  撣ĕ`
procedure TMainForm.MenuTryDrawAsIsClick(Sender: TObject);
begin
    LboxFont.Repaint;
end;



//=============================================================================
//
//  |bvAbvj[
//
//=============================================================================



//-----------------------------------------------------------------------------
//  j[\
procedure TMainForm.LboxFontMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
    Lbox: TListBox;
    Index: integer;
    Path: string;
    i: integer;
begin
    Lbox := TListBox(Sender);

    //  ENbNȂ
    if (Button = mbRight) then
    begin
        //  NbNʒumF
        Index := Lbox.ItemAtPos(Point(X, Y), True);

        //  f[^̂sȂ
        if (Index <> -1) then
        begin
            //  ł
            Lbox.SetFocus();
            Lbox.ItemIndex := Index;

            //  pXo
            Path := UFontPathList.Strings[Index];

            //  j[̃qgɃ^[QbgɂȂtHg̃pX
            //  j[̃^OɃXgł̃CfbNX
            for i := 0 to PopupMenu.Items.Count - 1 do
            begin
                PopupMenu.Items[i].Tag  := Index;
                PopupMenu.Items[i].Hint := Path;
            end;

            //  j[\
            PopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  ̃tHgCXg[
procedure TMainForm.PenuInstallClick(Sender: TObject);
var
    MenuItem: TMenuItem;
    FontFile: TInstallFont;
    R: TRect;
begin
    MenuItem := TMenuItem(Sender);
    FontFile := TInstallFont(UFontPathList.Objects[MenuItem.Tag]);
    FontFile.Install();
    R := LboxFont.ItemRect(MenuItem.Tag);
    InvalidateRect(LboxFont.Handle, @R, True);
    LboxFont.Update;
end;

//-----------------------------------------------------------------------------
//  ̃tHgACXg[
procedure TMainForm.PenuUninstallClick(Sender: TObject);
var
    MenuItem: TMenuItem;
    FontFile: TInstallFont;
    R: TRect;
begin
    MenuItem := TMenuItem(Sender);
    FontFile := TInstallFont(UFontPathList.Objects[MenuItem.Tag]);
    FontFile.UnInstall();
    R := LboxFont.ItemRect(MenuItem.Tag);
    InvalidateRect(LboxFont.Handle, @R, True);
    LboxFont.Update;
end;

//-----------------------------------------------------------------------------
//  GNXv[ɈϔC
procedure TMainForm.PenuOpenAsIsClick(Sender: TObject);
var
    MenuItem: TMenuItem;
begin
    MenuItem := TMenuItem(Sender);
    SimpleShellExecute(MenuItem.Hint);
end;

//-----------------------------------------------------------------------------
//  tHĝtH_J
procedure TMainForm.PenuOpenFolderInClick(Sender: TObject);
var
    MenuItem: TMenuItem;
begin
    MenuItem := TMenuItem(Sender);
    SimpleShellExecute(ExtractFilePath(MenuItem.Hint));
end;

//-----------------------------------------------------------------------------
//  vpeB_CAO\
procedure TMainForm.PenuPropertyClick(Sender: TObject);
var
    MenuItem: TMenuItem;
begin
    MenuItem := TMenuItem(Sender);
    OpenFilePropertyDialog(MenuItem.Hint);
end;

//-----------------------------------------------------------------------------
//  ̃tHgXg폜
procedure TMainForm.PenuDeleteFromListClick(Sender: TObject);
var
    MenuItem: TMenuItem;
    NewIndex: integer;
begin
    MenuItem := TMenuItem(Sender);
    DeleteFromManagerObject(MenuItem.Hint);

    //  ݑIʒuL^
    NewIndex := LboxFont.ItemIndex;
    //  Xg{bNX̍s炷
    LboxFont.Count := UFontPathList.Count;
    if (NewIndex >= LboxFont.Count) and (LboxFont.Count > 0) then Dec(NewIndex);
    //  VI
    LboxFont.ItemIndex := NewIndex;
end;

//-----------------------------------------------------------------------------
//  ACe`
procedure TMainForm.LboxFontDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
    LBox: TListBox;
    LCanvas: TCanvas;
    FontFile: TInstallFont;
    ItemText: string;
    uFormat: UINT;
    uFormatEx: TDrawTextParams;
    DispName: string;
    FontIndex: integer;
begin
    LBox := TListBox(Control);
    LCanvas := LBox.Canvas;
    FontFile := TInstallFont(UFontPathList.Objects[Index]);

    //  tH[JXI
    if (odFocused in State) and (odSelected in State) then
    begin
        LCanvas.Brush.Color := GC_BG_SELECT;
        LCanvas.Font.Color  := GC_FG_SELECT;
    end
    else
    //  tH[JXZ
    if (odFocused in State) then
    begin
        LCanvas.Brush.Color := GC_BG_FOCUSED;
        LCanvas.Font.Color  := GC_FG_FOCUSED;
    end
    else
    //  IZ
    if (odSelected in State) then
    begin
        LCanvas.Brush.Color := GC_BG_SELECT;
        LCanvas.Font.Color  := GC_FG_SELECT;
    end
    else
    //  ʏZ
    begin
        LCanvas.Brush.Color := GC_BG_NORMAL;
        LCanvas.Font.Color  := GC_FG_NORMAL;
    end;

    //  wihԂ
    LCanvas.FillRect(Rect);

    //  `e
    ItemText := ExtractFileName(FontFile.FilePath);
    if (FontFile.Installed) then ItemText := '[#] ' + ItemText
    else ItemText := '[ ] ' + ItemText;

    //  tHgɖ߂
    LBox.Canvas.Font.Assign(Self.Font);

    //  ̃tHg𗘗pĕ`悷
    if MenuTryDrawAsIs.Checked then
    begin
        FStrBuf.CommaText := FontFile.DispName;
        //  擾łĂ܂
        if FStrBuf.Count <> 0 then
        begin
            DispName := FStrBuf[0];
            FontIndex := ScreenFonts.Fonts.IndexOf(DispName);
            if (FontIndex <> -1) then
            begin
                LBox.Canvas.Font.Name := DispName;
                LBox.Canvas.Font.Charset := ScreenFonts.FontKeeper[FontIndex].TextMetrics.tmCharSet;
            end;
        end;
    end;

    //  `
    uFormat := DT_SINGLELINE or DT_VCENTER or DT_LEFT;
    FillChar(uFormatEx, SizeOf(uFormatEx), 0);
    uFormatEx.cbSize := SizeOf(uFormatEx);
    uFormatEx.iLeftMargin := 5;

    DrawTextEx(LCanvas.Handle, PChar(ItemText), -1, Rect, uFormat, @uFormatEx);
end;



//=============================================================================
//
//  ϊ
//
//=============================================================================



//-----------------------------------------------------------------------------
//  \tHg؂ւ
procedure TMainForm.ChangeMemoFont(const FontName: string; const FontCharSet: TFontCharset;
                        const FontSize: integer);
begin
    with MemConverted.Font do
    begin
        if (Name <> FontName) then Name := FontName;
        if (Charset <> FontCharSet) then Charset := FontCharSet;
        if (Size <> FontSize) then Size := FontSize;;
    end;
end;

//-----------------------------------------------------------------------------
//  \tHg؂ւ
procedure TMainForm.CboxScreenFontChange(Sender: TObject);
begin
    if (CboxScreenFont.ItemIndex <> -1) then
    begin
        ChangeMemoFont(
            CboxScreenFont.Text,
            ScreenFonts.FontKeeper[CboxScreenFont.ItemIndex].TextMetrics.tmCharSet,
            TbarFontSize.Position
        );
    end;
end;

//-----------------------------------------------------------------------------
//  GfBbg{bNXTuNX
procedure TMainForm.EditSubclassProc(var Msg: TMessage);
begin
    if (Msg.Msg = WM_IME_COMPOSITION) and (Msg.LParam = $1BF) then
    begin
        if IsLastCharHiragana(GetIMECompString(EboxKana, GCS_COMPSTR)) then
        begin
            keybd_event(VK_RETURN, 0, 0, 0);
            keybd_event(VK_RETURN, 0, KEYEVENTF_KEYUP, 0);
        end;
    end;
    EditPreProc(Msg);
end;

//-----------------------------------------------------------------------------
//  Subject: [Delphi:74817] Re: ͂ꂽЂ炪ȂɊm肳@
function TMainForm.GetIMECompString(CE: TCustomEdit; Index: DWORD): string;
var
    hIM	:HIMC;
    PC	:PChar;
    Len	:Integer;
begin
    hIM := ImmGetContext(CE.Handle);
    Len := ImmGetCompositionString(hIM, Index, nil, 0);
    GetMem(PC, Len + 1);
    FillChar(PC^, Len+1, #0);
    ImmGetCompositionString(hIM, Index, PC, Len);
    Result := PC;
    FreeMem(PC);
    ImmReleaseContext(CE.Handle, hIM);
end;

//-----------------------------------------------------------------------------
//  ǂ̔
function TMainForm.IsLastCharHiragana(s: string):Boolean;
var
    i, Len:integer;
    Ws:WideString;
begin
    Ws := s;
    Len := Length(Ws);
    result := True;
    for i := 1 to Len do
    begin
        if (Ord(Ws[i]) < $3040) or (Ord(Ws[i]) > $309F) then
        begin
            Result := False;
            Exit;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  ϊ
procedure TMainForm.EboxKanaChange(Sender: TObject);
begin
    MemConverted.Text := KanaToChars(EboxKana.Text);
end;

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------


//=============================================================================
//
//  EI
//
//=============================================================================

initialization
    //CreateManagerObject();
finalization
    //DestroyManagerObject();
end.

