(*
    ============================================================

    qgEBhẼJX^}CY

    http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N018.html

    ============================================================
*)

unit iHint;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms;

type
TLeftMarginPaintEvent = procedure (Sender: TObject;
                               R: TRect; Canvas: TCanvas) of object;

THintSetter = class(TComponent)
private
  FBkColor:TColor;
  FHintPause:integer;
  FLeftMargin:integer;
  FHeightMargin:integer;
  FFont:TFont;
  FOnLeftMaginPaint:TLeftMarginPaintEvent;
  procedure SetBkColor(const Value: TColor);
  procedure SetHintPause(const Value: integer);
  procedure SetFont(const Value: TFont);
protected
public
  constructor Create(AOwner: TComponent);override;
  destructor Destroy; override;
published
  property BkColor:TColor read FBkColor write SetBkColor;
  property HintPause:integer read FHintPause write SetHintPause;
  property LeftMargin:integer read FLeftMargin write FLeftMargin;
  property HeightMargin:integer read FHeightMargin write FHeightMargin;
  property Font:TFont read FFont write SetFont;
  property OnLeftMaginPaint:TLeftMarginPaintEvent read FOnLeftMaginPaint
                                                  write FOnLeftMaginPaint;
end;

implementation

//----------

var
  HintSetter:THintSetter;

type
TMyHint = class(THintWindow)
private
  FActivating: Boolean;
protected
  procedure Paint; override;
public
  procedure ActivateHint(Rect: TRect; const AHint: string); override;
  function CalcHintRect(MaxWidth: Integer; const AHint: string;
                                      AData: Pointer): TRect; override;
end;

{ ------------ THintSetter ------------ }

constructor THintSetter.Create(AOwner: TComponent);
begin
  inherited;
  FFont := TFont.Create;
  FFont.Assign(Screen.HintFont);

  HintSetter := self;

  FBkColor := Application.HintColor;
  FHintPause := 500;

  if not (csDesigning in ComponentState) then begin
    HintWindowClass := TMyHint;
    Application.ShowHint := false;
    Application.ShowHint := true;
  end;
end;

destructor THintSetter.Destroy;
begin
  FFont.Free;
  inherited;
end;

procedure THintSetter.SetBkColor(const Value: TColor);
begin
  FBkColor := Value;
  if not (csDesigning in ComponentState) then Application.HintColor := Value;
end;

procedure THintSetter.SetHintPause(const Value: integer);
begin
  FHintPause := Value;
  if not (csDesigning in ComponentState) then Application.HintPause := Value;
end;

procedure THintSetter.SetFont(const Value: TFont);
begin
  if FFont <> Value then FFont.Assign(Value);
end;

{ --------- TMyHint ------------ }

procedure TMyHint.ActivateHint(Rect: TRect; const AHint: string);
begin
  Inc(Rect.Right,HintSetter.LeftMargin);
  Inc(Rect.Bottom,HintSetter.HeightMargin);

  inherited;
end;

function TMyHint.CalcHintRect(MaxWidth: Integer; const AHint: string;
  AData: Pointer): TRect;
begin
  if Canvas.Font <> HintSetter.Font then Canvas.Font.Assign(HintSetter.Font);
  result := inherited CalcHintRect(MaxWidth,AHint,AData);
end;

procedure TMyHint.Paint;
var
  R: TRect;
  LM:integer;
begin
  FActivating := true;
  try
    R := ClientRect;
    LM := HintSetter.LeftMargin;

    if Assigned(HintSetter.OnLeftMaginPaint) and (LM > 0) then
      HintSetter.OnLeftMaginPaint(HintSetter,
        Rect(R.Left,R.Top,R.Left+LM-2,R.Bottom),Canvas);

    Canvas.Brush.Style := bsClear;

    Inc(R.Left,LM+2);
    DrawText(Canvas.Handle, PChar(Caption), -1, R,
                        DT_LEFT or DT_NOPREFIX or DT_VCENTER or DT_SINGLELINE);
  finally
    FActivating := false;
  end;
end;

end.

